//
// Added 8/17/2017 3:03:24 PM
//

#CONST
    // Display Replies
    ERR
    OK
    COMPLETE
#END


var fileData[4] := [0, 0, 0, -1];  // Size, Date, Time, Bank
var fileSize;

func rMagicObject0(var action, var object, var newVal, var *ptr)
    switch (action)
        case WRITE_MAGIC_BYTES:
            if (newVal != 8)
                 seroutX(NAK);
                 break;
            endif
            var i, j;
            txt_MoveCursor(5,0);
            for (i := 0; i < 4; i++)           // change endianness
                j := i * 2 ;
                fileData[i] := (ptr[j+1] << 8) + ptr[j] ;
            next
            file_Erase("temp0.4xe");
            seroutX(ACK);
            break;

        case WRITE_MAGIC_DBYTES:
            txt_MoveCursor(0,0);
            if (fileData[3] == -1)
                print("File Information hasn't been set");
                SendReport(REPORT_OBJ, tMagicObject, 0, ERR);
                break;
            endif

            var file, rem;
                file := file_Open("temp0.4xe", 'a');
            if (!file_Error())
                fileSize += newVal * 2;
                rem := fileData[0] - fileSize;

                file_Write(str_Ptr(ptr), newVal * 2 - ((rem == -1)? 1 : 0), file);

                print("Remaining Bytes: ", ((rem == -1)? 0: rem), "    ");
                if (rem <= 0)
                    file[FILE_DATE] := fileData[1];
                    file[FILE_TIME] := fileData[2];
                    file_Close(file);
                    var buf[10];
                    to (buf); print("RunBank", [DEC]fileData[3], ".4xe");
                    if (file_Erase(str_Ptr(buf)))
                        if (file_Rename("temp0.4xe", str_Ptr(buf)))
                            fileData[0] := 0;
                            fileData[1] := 0;
                            fileData[2] := 0;
                            fileData[3] := -1;
                            print("\nFile Completed");
                            SendReport(REPORT_OBJ, tMagicObject, 0, COMPLETE);
                        endif
                    endif
                    return;
                endif
                SendReport(REPORT_OBJ, tMagicObject, 0, OK);
                file_Close(file);
                return;
            endif

            print("Error Opening File");
            SendReport(REPORT_OBJ, tMagicObject, 0, ERR);
            break;

        default:
            break;
    endswitch
endfunc
